'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.inputSizes = undefined;

var _values = require('babel-runtime/core-js/object/values');

var _values2 = _interopRequireDefault(_values);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Input = require('./Input');

var _Input2 = _interopRequireDefault(_Input);

var _Password = require('./Password');

var _Password2 = _interopRequireDefault(_Password);

var _Mask = require('./Mask');

var _Mask2 = _interopRequireDefault(_Mask);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var TYPES = process.env.NODE_ENV !== "production" ? {
  DATE: 'date',
  MASK: 'mask',
  NUMBER: 'number',
  PASSWORD: 'password',
  SUI_PASSWORD: 'sui-password',
  TEXT: 'text',
  RADIO: 'radio',
  CHECKBOX: 'checkbox'
} : {};;

var AtomInput = function AtomInput(_ref) {
  var type = _ref.type,
      props = (0, _objectWithoutProperties3.default)(_ref, ['type']);

  switch (type) {
    case 'sui-password':
      return _react2.default.createElement(_Password2.default, props);
    case 'mask':
      return _react2.default.createElement(_Mask2.default, props);
    default:
      return _react2.default.createElement(_Input2.default, (0, _extends3.default)({}, props, { type: type }));
  }
};

AtomInput.propTypes = process.env.NODE_ENV !== "production" ? process.env.NODE_ENV !== "production" ? {
  /* native types (text, date, ...), 'sui-password' */
  type: _propTypes2.default.oneOf((0, _values2.default)(TYPES)),

  /* Left addon component, text,... */
  leftAddon: _propTypes2.default.any,

  /* Right addon component, text,... */
  rightAddon: _propTypes2.default.any,

  /* Left Icon */
  leftIcon: _propTypes2.default.any,

  /* Left Icon */
  rightIcon: _propTypes2.default.any,

  /* Left icon click callback */
  onClickLeftIcon: _propTypes2.default.func,

  /* Right icon click callback */
  onClickRightIcon: _propTypes2.default.func,

  /* Text to be shown in order to show the password on click */
  pwShowLabel: _propTypes2.default.string,

  /* Text to be shown in order to hide the password on click */
  pwHideLabel: _propTypes2.default.string,

  /* onBlur callback */
  onBlur: _propTypes2.default.func,

  /* onChange callback */
  onChange: _propTypes2.default.func,

  /* sets the name property of an element in the DOM */
  name: _propTypes2.default.string,

  /* The DOM id global attribute. */
  id: _propTypes2.default.string,

  /* A hint to the user of what can be entered in the control. The placeholder text must not contain carriage returns or line-feeds. */
  placeholder: _propTypes2.default.string,

  /* This Boolean attribute prevents the user from interacting with the input */
  disabled: _propTypes2.default.bool,

  /* 's' or 'm', default: 'm' */
  size: _propTypes2.default.oneOf((0, _values2.default)(_Input.inputSizes)),

  /* width of input based in number of characters (native "size" attribute) */
  charsSize: _propTypes2.default.number,

  /* true = error, false = success, null = neutral */
  errorState: _propTypes2.default.bool,

  /* value of the control */
  value: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.bool]),

  /* mask object, see https://unmanner.github.io/imaskjs/ */
  mask: _propTypes2.default.object
} : {} : {};

AtomInput.displayName = 'AtomInput';

exports.default = AtomInput;
exports.inputSizes = _Input.inputSizes;